dnl -------------------------------------------------------------------
dnl A Sendmail Cookbook
dnl
dnl Contributed by Anthony Howe
dnl -------------------------------------------------------------------

dnl LOCAL_RULESETS
dnl #
dnl # A variant of FEATURE(`relay_mail_from'), which relays mail based
dnl # on an entry in the virtusertable. This can be abused by spammers. 
dnl #
dnl SLocal_check_rcpt
dnl R$*                     $: $>canonify $&f          
dnl R$+ < @ $=w . >         $: <RESULT: $( virtuser $1 @ $2 $: $) >
dnl R<RESULT: $+ >          $# OK      

dnl -------------------------------------------------------------------

dnl LOCAL_CONFIG
dnl Kassign macro
dnl
dnl LOCAL_RULESETS
dnl #
dnl # Save the envelope recipient (RCPT TO) argument. This may be
dnl # different from {rcpt_addr}.
dnl #
dnl SLocal_check_rcpt		
dnl R$*				$: $(assign {rcpt_to} $@ $1 $)
dnl
dnl #
dnl # Relay if the recipient's domain appears in mailertable.
dnl # This rule is appended to the end of ruleset `Relay_ok'.
dnl #
dnl SRelay_ok
dnl R$*				$: $>canonify $&{rcpt_to}
dnl R$+ < @ $+ . >		$: $( mailertable $2 $)
dnl R$+ < @ $+ . $+ . >		$: $( mailertable . $3 $)
dnl Resmtp: $+			$@ RELAY

dnl -------------------------------------------------------------------

dnl #
dnl # Sendmail rules for a "claims to be us" test.
dnl #
dnl # 	http://www.cs.niu.edu/~rickert/cf/bad-ehlo.html
dnl #
dnl # Client software is often broken.  We don't want to reject
dnl # our own users client connections.  Therefore we attempt
dnl # to allow our users to pass the checks.  Otherwise, block
dnl # sites with a HELO/EHLO hostname that is unqualified, or
dnl # is one of our own names
dnl # 
dnl # Note that I had to at "127.0.0.1" to class $=R, so that
dnl # local client software would bypass these tests.  I also
dnl # added "[127.0.0.1]" to class $=w, so that the localhost
dnl # IP would count as one of our IPs.
dnl # 
dnl RELAY_DOMAIN(`127.0.0.1')dnl
dnl LOCAL_DOMAIN(`[127.0.0.1]')dnl
dnl
dnl LOCAL_RULESETS
dnl SLocal_check_rcpt
dnl $*			$:$1 $| <$&{auth_authen}>	Get auth info
dnl # Bypass the test for users who have authenticated.
dnl $* $| <$+>		$:$1				skip if auth
dnl $* $| <$*>		$:$1 $| <$&{client_addr}>[$&s]	Get connection info
dnl # Bypass for local clients -- IP address starts with $=R
dnl $* $| <$=R $*>[$*]	$:$1				skip if local client
dnl # Bypass a "sendmail -bs" session, which use 0 for client ip address
dnl $* $| <0>[$*]	$:$1				skip if sendmail -bs
dnl # Reject our IP - assumes "[ip]" is in class $=w
dnl $* $| <$*> $=w	$#error $@5.7.1 $:"550 bogus HELO name used: " $&s
dnl # Reject our hostname
dnl $* $| <$*> [$=w]	$#error $@5.7.1 $:"550 bogus HELO name used: " $&s
dnl # Pass anything else with a "." in the domain parameter
dnl $* $| <$*> [$+.$+]	$:$1				qualified domain ok
dnl # Reject if there was no "." or only an initial or final "."
dnl $* $| <$*> [$*]	$#error $@5.7.1 $:"550 bogus HELO name used: " $&s
dnl # fall through to any other local rules.
